<template>
  <!-- 冰排管理 -->
  <div>
    <actionBar :operateList="operateList" :formList="formList" :ruleForm="searchRuleForm" @openModel="openModel"
      @searchProtocol="searchProtocol"></actionBar>
    <div class="card_content">
      <!-- 表单 -->
      <tables :tableList="tableList" :tableData="tableData" @buttonData="buttonData"></tables>
      <!-- 分页 -->
      <div v-if="Total">
        <pagination :total="Total" :currentPage="Pagination.PageIndex" @changeSize="changeSize"
          @changeCurrent="changeCurrent">
        </pagination>
      </div>
    </div>
    <el-dialog :title="staffTitle" :visible.sync="staffDialogVisible" width="600px" :close-on-click-modal="false"
      @close="closeDialog">
      <forms ref="childRules" :iceBank="true" :iceTracing="iceTracing" :formNewList="formRuleList" :ruleForm="ruleForm"
        labelWidth="100px">
      </forms>
      <span slot="footer" class="dialog-footer" v-if="operationType != 'logs'">
        <el-button plain @click="staffDialogVisible = false">取 消</el-button>
        <el-button type="primary" :loading="confirmLoading" @click="handleAdd">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
  import {
    getIceRaft,
    addIceRaft,
    putIceRaft,
    delIceRaft
  } from '@/api/freezer'
  import actionBar from '@/components/actionBar'
  import tables from '@/components/tables'
  import pagination from '@/components/pagination'
  import forms from '@/components/forms'
  import {
    formRules,
    formRulesCold,
    employee,
    employeeCold
  } from "./freezer.js";
  import {
    iceraftStatus
  } from '@/assets/js/blockSort'
  export default {
    name: 'IceManagement',
    components: {
      actionBar,
      tables,
      pagination,
      forms
    },
    data() {
      return {
        operateList: [{
          type: 'add',
          title: '添加',
          icon: 'el-icon-plus',
        }],
        formList: [{
          type: 'input',
          label: '编号',
          field: 'code',
          placeholder: '请输入编号',
        }, {
          type: 'select',
          label: '状态',
          field: 'status',
          placeholder: '请选择状态',
          options: iceraftStatus(),
        }],
        searchRuleForm: {
          code: '',
          status: '',
        },
        searchValue: {},
        Pagination: {
          PageIndex: 1,
          PageSize: 10,
        },
        Total: 0,
        tableData: [],
        operationType: '',
        tableList: [],
        staffTitle: '添加',
        staffDialogVisible: false,
        formRuleList: [],
        ruleForm: {
          code: '',
          status: null,
          freezeClaim: [],
          label: '',
          suitableForCold: null,
          iceColdAddress: '',
        },
        confirmLoading: false,
        selectingData: {},
        iceTracing: true,
        // 是否释冷
        iceColdFlag: false,
        userList: {},
      }
    },
    mounted() {
      const arr = localStorage.getItem('userList')
      this.userList = JSON.parse(arr)
      if (this.userList.dept) {
        this.iceColdFlag = this.userList.dept.isIceReleaseCold
      }
      if (this.iceColdFlag) {
        this.tableList = employeeCold()
        this.formRuleList = formRulesCold()
      } else {
        this.tableList = employee()
        this.formRuleList = formRules()
      }
      this.getList()
    },
    methods: {
      // 搜索
      searchProtocol(value) {
        this.Pagination.PageIndex = 1
        this.searchValue = value
        this.getList()
      },
      // 获取列表
      getList() {
        var params = {
          page: this.Pagination.PageIndex,
          pageSize: this.Pagination.PageSize,
          ...this.searchValue
        }
        getIceRaft(params).then(res => {
          if (res.code == 200) {
            this.tableData = res.data.list
            this.Total = res.data.count
          }
        })
      },
      // 弹窗表单添加
      handleAdd() {
        let flag = this.$refs['childRules'].validateForm();
        if (flag) {
          var turnNum = function(nums) {
            return nums.map(Number);
          }
          if (this.operationType == 'add') {
            this.confirmLoading = true
            let arr = []
            arr.push(this.ruleForm.code)
            var params = {
              codeList: arr,
              status: this.ruleForm.status,
              freezeClaim: turnNum(this.ruleForm.freezeClaim),
              label: this.ruleForm.label,
              suitableForCold: Number(this.ruleForm.suitableForCold),
              iceColdAddress: this.ruleForm.iceColdAddress,
            }
            addIceRaft(params).then(res => {
              if (res.code == 200) {
                this.$message({
                  message: '操作成功',
                  type: 'success'
                });
                this.getList()
              }
              this.staffDialogVisible = false
              this.confirmLoading = false
            }).catch(() => {
              this.confirmLoading = false
            })
          } else if (this.operationType == 'edit') {
            this.confirmLoading = true
            var params = {
              id: this.selectingData.id,
              code: this.ruleForm.code,
              status: this.ruleForm.status,
              freezeClaim: turnNum(this.ruleForm.freezeClaim),
              label: this.ruleForm.label,
              suitableForCold: Number(this.ruleForm.suitableForCold),
              iceColdAddress: this.ruleForm.iceColdAddress,
            }
            putIceRaft(params).then(res => {
              if (res.code == 200) {
                this.$message({
                  message: '操作成功',
                  type: 'success'
                });
                this.getList()
              }
              this.staffDialogVisible = false
              this.confirmLoading = false
            }).catch(() => {
              this.confirmLoading = false
            })
          }
        } else {
          this.$message.error('表单信息不完整，请继续填写完整');
        }
      },
      buttonData(row, type) {
        this.selectingData = row
        this.operationType = type
        if (type == 'edit') {
          this.iceTracing = false
          this.staffTitle = '编辑'
          this.staffDialogVisible = true
          setTimeout(() => {
            this.$nextTick(() => {
              this.ruleForm.code = row.code
              this.ruleForm.status = row.status
              this.ruleForm.freezeClaim = row.freezeClaim.map(String);
              this.ruleForm.label = row.label
              this.ruleForm.suitableForCold = row.suitableForCold
              this.ruleForm.iceColdAddress = row.iceColdAddress
            })
          })
        } else if (type == 'logs') {
          this.iceTracing = false
          this.staffTitle = '详情'
          this.staffDialogVisible = true
          setTimeout(() => {
            this.$nextTick(() => {
              this.ruleForm.code = row.code
              this.ruleForm.status = row.status
              this.ruleForm.freezeClaim = row.freezeClaim
              this.ruleForm.label = row.label
              this.ruleForm.suitableForColdTime = row.suitableForColdTime
            })
          })
          this.formRuleList.forEach((item, index) => {
            item.disabled = true
          })
        } else if (type == 'del') {
          this.deleteUser(row.id)
        }
      },
      openModel(type) {
        this.iceTracing = true
        this.staffTitle = '添加'
        this.staffDialogVisible = true
        this.operationType = type
      },
      // 删除冰排
      deleteUser(id) {
        this.$confirm('此操作将永久删除该冰排, 是否继续?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          delIceRaft({
            id: id,
          }).then(res => {
            if (res.code == 200) {
              this.$message({
                message: '操作成功',
                type: 'success'
              });

              const precisePage = Math.ceil((this.Total - 1) / this.Pagination.PageSize)
              this.Pagination.PageIndex = this.Pagination.PageIndex > precisePage ? precisePage : this
                .Pagination.PageIndex
              this.Pagination.PageIndex = this.Pagination.PageIndex < 1 ? 1 : this.Pagination.PageIndex
              this.getList()
            }
          })
        }).catch(() => {});
      },
      changeSize(val) {
        this.Pagination.PageSize = val
        this.getList()
      },
      changeCurrent(val) {
        this.Pagination.PageIndex = val
        this.getList()
      },
      // 清空表单
      closeDialog() {
        this.$refs.childRules.resetCheck();
      }
    },
  }
</script>

<style>
</style>
